// ActiveList.java
// Fall 2004, COP4331: Online auction example application
// 


/**
   the active auction list class.

   <BR>
   <B>NOTE:</B> 
   The purpose of this code is to illustrate implementation starting 
   from UML class and sequence diagrams. It may be incomplete and may not 
   compile.
*/
public class ActiveList {
    /**
       constructs the ActiveList
    */
    public ActiveList(ListingArchive arch) {
	this.arch = arch;
	this.auctListings = new java.util.ArrayList<AuctionListing>();
    }

    /**
       remove auction listing from the list. 
       It is derived from the "Complete Auction" use case.
     */
    public void removeListing(AuctionListing al) {
	// List.remove(Object) returns false if it fails:
	if (! this.auctListings.remove(al)) {
	    // could not remove al. Indicate an error
	    // ... omitted
	}
	else {
	    // success !
	    // do nothing else here.
	}
    }

    /**
       list a new item. 
       Derived from the "List Item" use case.
       @param it the new item for sale
       @param deadline the auction deadline
       @param price the starting price
       @return the new AuctionListing object for this item
    */
    public AuctionListing listItem(Seller seller, Item it, java.util.Date deadline, double price) {
	// create new AuctionListing (call constructor):
	AuctionListing al = new AuctionListing(seller, it, deadline, price);
	
	// create auctioneer for this listing:
	Auctioneer au = new Auctioneer(this, al, this.arch);
	// auctioneer needs the archive for "Complete Auction" use case.

	// save the Auctioneer to the AuctionListing:
	al.setAuctioneer(au);
	
	// implementation choice: validateListing() returns true/false
	// if validation succeeds, add to ActiveList:
	if (au.validateListing()) {
	    
	    // add the new auction listing:
	    this.auctListings.add(al);
	    
	    // schedule auction completion:
	    au.scheduleCompletion();
	}
	else {
	    // indicate error to user
	    // ... omitted ...

	    al = null;
	}

	return al;
    }

    /**
       creates and returns a browseable list of auction listings.
       This list is a shallow copy of the active list's content.
       Derived from the "Browse Items" use case".
       @return a browseable list of auction listings
    */
    public BrowseList getBrowseList() {
	BrowseList bl = new BrowseList();

	// get an iterator:
	java.util.Iterator<AuctionListing> it = this.list.iterator();

	// browse elements:
	while (it.hasNext()) {
	    // add to browse list:
	    bl.addListing(it.next());
	}

	// or replace previous loop with:
	//   for (AuctionListing al: this.auctListings) {
	//       bl.addListing(al);
	//   }

	return bl;
    }
    
    // instance variables:
    /**
       collection of AuctionListing objects:
    */
    private java.util.ArrayList<AuctionListing> auctListings;

    /**
       auction listing archive
    */
    private ListingArchive arch;

};
