// AuctionListing.java
// Fall 2004, COP4331: Online auction example application
// 


/**
   the auction listing class. It encapsulates all the information and 
   object references necessary for the Auctioneer to do its jobs.

   NOTE: The purpose of this code is to illustrate implementation starting 
   from UML class and sequence diagrams. It may be incomplete and may not 
   compile.
*/
public class AuctionListing {
    /**
       constructs the ActiveList
       @param seller the Seller object
       @param it the Item
       @param deadline the auction deadline
       @param price the initial auction price
    */
    public AuctionListing(Seller seller, Item it, java.util.Date deadline, double price) {
	this.seller = seller;
	this.item = it;
	this.deadline = deadline;
	this.price = price;
    }

    /**
       sets the auctioneer object reference. This mutator is called by the
       ActiveList when it lists a new item.
       @see ActiveList
       @param auctioneer the auctioneer reference
    */
    public void setAuctioneer(Auctioneer auctioneer) {
	this.auctioneer = auctioneer;
    }


    /**
       gets the auctioneer object reference. 
       Called by the buyer role.
       @return the auctioneer reference
    */
    public Auctioneer getAuctioneer() {
	return this.auctioneer;
    }

    /**
       process a new bid for this auction.
       Derived from "Bid for Item" use case.
       @param bid the bid object
    */
    public void addBid(Bid bid) {
	// add to bid history
	this.bidHist.addBid(bid);
    }

    /**
       accessor for the current highest bid. Returns null if there is no bid.
       Derived from the "Complete Auction" use case.
    */
    public Bid getHighestBid() {
	// delegate to bid history object:
	return this.bidHist.getHighestBid();
    };

    // accessors:
    public Seller getSeller() {
	return this.seller;
    };

    public Item getItem() {
	return this.item;
    }

    public java.util.Date getDeadline() {
	return this.deadline;
    }
        
    public double getPrice() {
	return this.startPrice;
    }

    // private instance variables:
    // object references from aggregations and associations:
    private Item item;
    
    private BidHistory bidHist;
    
    private Seller seller;
    
    private Auctioneer auctioneer;
    
    // object attributes:
    java.util.Date deadline;              // auction deadline
    
    double startPrice;          // the auction starting price
};

