// AuctionSystem.java
// Fall 2004, COP4331: Online auction example application
// 


/**
   the auction system class. Aggregates the main system components and
   provides entry points for user services.

   NOTE: The purpose of this code is to illustrate implementation starting 
   from UML class and sequence diagrams. It may be incomplete and may not 
   compile.
*/
public class AuctionSystem {

    /**
       constructs the auction system
    */
    public AuctionSystem() {
	this.arch = new ListingArchive();
	this.activeList = new ActiveList(this.arch);
    }

    /**
       return a browseable list of active listings, but NOT the ActiveList object.
       
       Derived from the "Browse Items" use case.
       @return a browseable list of active listings, but NOT the ActiveList object.
     */
    public BrowseList getBrowseList() {
	return this.activeList.getBrowseList();
    }


    /**
       adds a new Item for sale.
       
       Derived from the "List an Item" use case.
       @param item the new item for sale
       @param deadline the auction deadline
       @param price the starting price
       @return the new AuctionListing object for this item
    */
    public AuctionListing listItem(Item item, java.util.Date deadline, double price) {
	return this.activeList.listItem(item, deadline, price);
    }
    

    // aggregations:
    /**
       the active auctions list
    */
    private ActiveList activeList;

    /**
       the listing archive
    */
    private ListingArchive arch;
}
