// ListingArchive.java
// Fall 2004, COP4331: Online auction example application
// 


/**
   the auction listing archive class.

   NOTE: The purpose of this code is to illustrate implementation starting 
   from UML class and sequence diagrams. It may be incomplete and may not 
   compile.
*/
public class ListingArchive {
    /**
       constructs the ListingArchive
    */
    public ListingArchive() {
	this.list = new java.util.LinkedList<AuctionListing>();
    }

    /**
       save a listing to the archive.
       Derived from the "Complete Auction" use case.
       @param al the auction listing
    */
    public void addListing(AuctionListing al) {
	this.list.add(al);
    }
    
    // !!!!!!!!!!!!!!!!!!!!!!
    // the current use cases do not need other operations
    // (the archive has no responsibility other than saving listings)
    // Eventually, for new requirements/features, we will write use cases 
    // that access the archive content. New functionality will be added
    // to the ListingArchive class by subclassing. This is why the list
    // instance variable is "protected" - to give access to subclasses.
    


    // instance variable:
    /**
       collection of AuctionListing objects. <CODE>List</CODE> is an interface type.
       It is <B>protected</B> to give access to subclasses to add functionality 
       (such as browsing the archive).
    */
    protected java.util.List<AuctionListing> list;
};
